diff --git a/gcc/jit/libgccjit++.h b/gcc/jit/libgccjit++.h
index 69e67766640..31256628cf4 100644
--- a/gcc/jit/libgccjit++.h
+++ b/gcc/jit/libgccjit++.h
@@ -46,6 +46,7 @@ namespace gccjit
      class lvalue;
        class param;
     class case_;
+    class extended_asm;
   class timer;
   class auto_time;
 
@@ -316,6 +317,8 @@ namespace gccjit
 		    rvalue max_value,
 		    block dest_block);
 
+    void add_top_level_asm (const char *asm_stmts);
+
   private:
     gcc_jit_context *m_inner_ctxt;
   };
@@ -449,6 +452,13 @@ namespace gccjit
 			  block default_block,
 			  std::vector <case_> cases,
 			  location loc = location ());
+
+    extended_asm add_extended_asm (const std::string &asm_template,
+				   location loc = location ());
+    extended_asm end_with_extended_asm_goto (const std::string &asm_template,
+					     std::vector<block> goto_blocks,
+					     block *fallthrough_block,
+					     location loc = location ());
   };
 
   class rvalue : public object
@@ -508,6 +518,40 @@ namespace gccjit
     gcc_jit_case *get_inner_case () const;
   };
 
+  class extended_asm : public object
+  {
+  public:
+    extended_asm ();
+    extended_asm (gcc_jit_extended_asm *inner);
+
+    extended_asm &
+    set_volatile_flag (bool flag);
+
+    extended_asm &
+    set_inline_flag (bool flag);
+
+    extended_asm&
+    add_output_operand (const std::string &asm_symbolic_name,
+			const std::string &constraint,
+			gccjit::lvalue dest);
+    extended_asm&
+    add_output_operand (const std::string &constraint,
+			gccjit::lvalue dest);
+
+    extended_asm&
+    add_input_operand (const std::string &asm_symbolic_name,
+		       const std::string &constraint,
+		       gccjit::rvalue src);
+    extended_asm&
+    add_input_operand (const std::string &constraint,
+		       gccjit::rvalue src);
+
+    extended_asm&
+    add_clobber (const std::string &victim);
+
+    gcc_jit_extended_asm *get_inner_extended_asm () const;
+  };
+
   /* Overloaded operators, for those who want the most terse API
      (at the possible risk of being a little too magical).
 
@@ -1258,6 +1302,12 @@ context::new_case (rvalue min_value,
 					  dest_block.get_inner_block ()));
 }
 
+inline void
+context::add_top_level_asm (const char *asm_stmts)
+{
+  gcc_jit_context_add_top_level_asm (m_inner_ctxt, asm_stmts);
+}
+
 // class object
 inline context
 object::get_context () const
@@ -1553,6 +1603,37 @@ block::end_with_switch (rvalue expr,
 				 as_array_of_ptrs);
 }
 
+inline extended_asm
+block::add_extended_asm (const std::string &asm_template,
+			 location loc)
+{
+  return gcc_jit_block_add_extended_asm (get_inner_block (),
+					 loc.get_inner_location (),
+					 asm_template.c_str ());
+}
+
+inline extended_asm
+block::end_with_extended_asm_goto (const std::string &asm_template,
+				   std::vector<block> goto_blocks,
+				   block *fallthrough_block,
+				   location loc)
+{
+  /* Treat std::vector as an array, relying on it not being resized: */
+  block *as_array_of_wrappers = &goto_blocks[0];
+
+  /* Treat the array as being of the underlying pointers, relying on
+     the wrapper type being such a pointer internally.  */
+  gcc_jit_block **as_array_of_ptrs =
+    reinterpret_cast<gcc_jit_block **> (as_array_of_wrappers);
+  return gcc_jit_block_end_with_extended_asm_goto
+    (get_inner_block (),
+     loc.get_inner_location (),
+     asm_template.c_str (),
+     goto_blocks.size (),
+     as_array_of_ptrs,
+     fallthrough_block ? fallthrough_block->get_inner_block () : NULL);
+}
+
 inline rvalue
 block::add_call (function other,
 		 location loc)
@@ -1757,6 +1838,92 @@ case_::get_inner_case () const
   return reinterpret_cast<gcc_jit_case *> (get_inner_object ());
 }
 
+// class extended_asm : public object
+inline extended_asm::extended_asm () : object () {}
+inline extended_asm::extended_asm (gcc_jit_extended_asm *inner)
+  : object (gcc_jit_extended_asm_as_object (inner))
+{
+}
+
+inline extended_asm&
+extended_asm::set_volatile_flag (bool flag)
+{
+  gcc_jit_extended_asm_set_volatile_flag (get_inner_extended_asm (), flag);
+  return *this;
+}
+
+inline extended_asm&
+extended_asm::set_inline_flag (bool flag)
+{
+  gcc_jit_extended_asm_set_inline_flag (get_inner_extended_asm (), flag);
+  return *this;
+}
+
+inline extended_asm&
+extended_asm::add_output_operand (const std::string &asm_symbolic_name,
+				  const std::string &constraint,
+				  gccjit::lvalue dest)
+{
+  gcc_jit_extended_asm_add_output_operand
+    (get_inner_extended_asm (),
+     asm_symbolic_name.c_str (),
+     constraint.c_str (),
+     dest.get_inner_lvalue ());
+  return *this;
+}
+
+inline extended_asm&
+extended_asm::add_output_operand (const std::string &constraint,
+				  gccjit::lvalue dest)
+{
+  gcc_jit_extended_asm_add_output_operand
+    (get_inner_extended_asm (),
+     NULL, /* asm_symbolic_name */
+     constraint.c_str (),
+     dest.get_inner_lvalue ());
+  return *this;
+}
+
+inline extended_asm&
+extended_asm::add_input_operand (const std::string &asm_symbolic_name,
+				 const std::string &constraint,
+				 gccjit::rvalue src)
+{
+  gcc_jit_extended_asm_add_input_operand
+    (get_inner_extended_asm (),
+     asm_symbolic_name.c_str (),
+     constraint.c_str (),
+     src.get_inner_rvalue ());
+  return *this;
+}
+
+inline extended_asm&
+extended_asm::add_input_operand (const std::string &constraint,
+				 gccjit::rvalue src)
+{
+  gcc_jit_extended_asm_add_input_operand
+    (get_inner_extended_asm (),
+     NULL, /* asm_symbolic_name */
+     constraint.c_str (),
+     src.get_inner_rvalue ());
+  return *this;
+}
+
+inline extended_asm&
+extended_asm::add_clobber (const std::string &victim)
+{
+  gcc_jit_extended_asm_add_clobber (get_inner_extended_asm (),
+				    victim.c_str ());
+  return *this;
+}
+
+inline gcc_jit_extended_asm *
+extended_asm::get_inner_extended_asm () const
+{
+  /* Manual downcast: */
+  return reinterpret_cast<gcc_jit_extended_asm *> (get_inner_object ());
+}
+
 /* Overloaded operators.  */
 // Unary operators
 inline rvalue operator- (rvalue a)
diff --git a/gcc/jit/libgccjit.c b/gcc/jit/libgccjit.c
index 3d04f6db3af..37bd1e5e2b3 100644
--- a/gcc/jit/libgccjit.c
+++ b/gcc/jit/libgccjit.c
@@ -96,6 +96,11 @@ struct gcc_jit_timer : public timer
 {
 };
 
+struct gcc_jit_extended_asm : public gcc::jit::recording::extended_asm
+{
+};
+
+
 /**********************************************************************
  Error-handling.
 
@@ -300,13 +305,13 @@ struct gcc_jit_timer : public timer
 
 static void
 jit_error (gcc::jit::recording::context *ctxt,
-	   gcc_jit_location *loc,
+	   gcc::jit::recording::location *loc,
 	   const char *fmt, ...)
   GNU_PRINTF(3, 4);
 
 static void
 jit_error (gcc::jit::recording::context *ctxt,
-	   gcc_jit_location *loc,
+	   gcc::jit::recording::location *loc,
 	   const char *fmt, ...)
 {
   va_list ap;
@@ -3247,3 +3252,156 @@ gcc_jit_version_patchlevel (void)
   version_info vi;
   return vi.patchlevel;
 }
+
+/**********************************************************************
+ Asm support.
+ **********************************************************************/
+
+/* FIXME.  */
+
+gcc_jit_extended_asm *
+gcc_jit_block_add_extended_asm (gcc_jit_block *block,
+				gcc_jit_location *loc,
+				const char *asm_template)
+{
+  RETURN_NULL_IF_NOT_VALID_BLOCK (block, loc);
+  gcc::jit::recording::context *ctxt = block->get_context ();
+  JIT_LOG_FUNC (ctxt->get_logger ());
+  /* LOC can be NULL.  */
+  RETURN_NULL_IF_FAIL (asm_template, ctxt, loc, "NULL asm_template");
+
+  return (gcc_jit_extended_asm *)block->add_extended_asm (loc, asm_template);
+}
+
+/* FIXME.  */
+
+gcc_jit_extended_asm *
+gcc_jit_block_end_with_extended_asm_goto (gcc_jit_block *block,
+					  gcc_jit_location *loc,
+					  const char *asm_template,
+					  int num_goto_blocks,
+					  gcc_jit_block **goto_blocks,
+					  gcc_jit_block *fallthrough_block)
+{
+  RETURN_NULL_IF_NOT_VALID_BLOCK (block, loc);
+  gcc::jit::recording::context *ctxt = block->get_context ();
+  JIT_LOG_FUNC (ctxt->get_logger ());
+  /* LOC can be NULL.  */
+  RETURN_NULL_IF_FAIL (asm_template, ctxt, loc, "NULL asm_template");
+  RETURN_NULL_IF_FAIL (num_goto_blocks >= 0, ctxt, loc, "num_goto_blocks < 0");
+  for (int i = 0; i < num_goto_blocks; i++)
+    RETURN_NULL_IF_FAIL_PRINTF1 (goto_blocks[i],
+				 ctxt, loc,
+				 "NULL goto_blocks[%i]", i);
+  /* fallthrough_block can be NULL.  */
+  return (gcc_jit_extended_asm *)block->end_with_extended_asm_goto
+    (loc, asm_template,
+     num_goto_blocks, (gcc::jit::recording::block **)goto_blocks,
+     fallthrough_block);
+}
+
+/* Public entrypoint.  See description in libgccjit.h.
+
+   After error-checking, this calls the trivial
+   gcc::jit::recording::memento::as_object method (an extended_asm is a
+   memento), in jit-recording.h.  */
+
+gcc_jit_object *
+gcc_jit_extended_asm_as_object (gcc_jit_extended_asm *ext_asm)
+{
+  RETURN_NULL_IF_FAIL (ext_asm, NULL, NULL, "NULL ext_asm");
+
+  return static_cast <gcc_jit_object *> (ext_asm->as_object ());
+}
+
+/* Public entrypoint.  See description in libgccjit.h.
+
+   FIXME.  */
+
+void
+gcc_jit_extended_asm_set_volatile_flag (gcc_jit_extended_asm *ext_asm,
+					int flag)
+{
+  RETURN_IF_FAIL (ext_asm, NULL, NULL, "NULL ext_asm");
+  ext_asm->set_volatile_flag (flag);
+}
+
+/* Public entrypoint.  See description in libgccjit.h.
+
+   FIXME.  */
+
+void
+gcc_jit_extended_asm_set_inline_flag (gcc_jit_extended_asm *ext_asm,
+				      int flag)
+{
+  RETURN_IF_FAIL (ext_asm, NULL, NULL, "NULL ext_asm");
+  ext_asm->set_inline_flag (flag);
+}
+
+/* Public entrypoint.  See description in libgccjit.h.
+
+   FIXME.  */
+
+void
+gcc_jit_extended_asm_add_output_operand (gcc_jit_extended_asm *ext_asm,
+					 const char *asm_symbolic_name,
+					 const char *constraint,
+					 gcc_jit_lvalue *dest)
+{
+  RETURN_IF_FAIL (ext_asm, NULL, NULL, "NULL ext_asm");
+  gcc::jit::recording::context *ctxt = ext_asm->get_context ();
+  gcc::jit::recording::location *loc = ext_asm->get_loc ();
+  /* asm_symbolic_name can be NULL.  */
+  RETURN_IF_FAIL (constraint, ctxt, loc, "NULL constraint");
+  RETURN_IF_FAIL (dest, ctxt, loc, "NULL dest");
+  RETURN_IF_FAIL (!ext_asm->is_goto (), ctxt, loc,
+		  "cannot add output operand to asm goto");
+  ext_asm->add_output_operand (asm_symbolic_name, constraint, dest);
+}
+
+/* Public entrypoint.  See description in libgccjit.h.
+
+   FIXME.  */
+
+extern void
+gcc_jit_extended_asm_add_input_operand (gcc_jit_extended_asm *ext_asm,
+					const char *asm_symbolic_name,
+					const char *constraint,
+					gcc_jit_rvalue *src)
+{
+  RETURN_IF_FAIL (ext_asm, NULL, NULL, "NULL ext_asm");
+  gcc::jit::recording::context *ctxt = ext_asm->get_context ();
+  gcc::jit::recording::location *loc = ext_asm->get_loc ();
+  /* asm_symbolic_name can be NULL.  */
+  RETURN_IF_FAIL (constraint, ctxt, loc, "NULL constraint");
+  RETURN_IF_FAIL (src, ctxt, loc, "NULL src");
+  ext_asm->add_input_operand (asm_symbolic_name, constraint, src);
+}
+
+/* Public entrypoint.  See description in libgccjit.h.
+
+   FIXME.  */
+
+void
+gcc_jit_extended_asm_add_clobber (gcc_jit_extended_asm *ext_asm,
+				  const char *victim)
+{
+  RETURN_IF_FAIL (ext_asm, NULL, NULL, "NULL ext_asm");
+  gcc::jit::recording::context *ctxt = ext_asm->get_context ();
+  gcc::jit::recording::location *loc = ext_asm->get_loc ();
+  RETURN_IF_FAIL (victim, ctxt, loc, "NULL victim");
+  ext_asm->add_clobber (victim);
+}
+
+/* Public entrypoint.  See description in libgccjit.h.
+
+   FIXME.  */
+
+void
+gcc_jit_context_add_top_level_asm (gcc_jit_context *ctxt,
+				   const char *asm_stmts)
+{
+  RETURN_IF_FAIL (ctxt, NULL, NULL, "NULL ctxt");
+  RETURN_IF_FAIL (asm_stmts, ctxt, NULL, "NULL asm_stmts");
+  ctxt->add_top_level_asm (asm_stmts);
+}
diff --git a/gcc/jit/libgccjit.h b/gcc/jit/libgccjit.h
index 1c5a12e9c01..f118ed31368 100644
--- a/gcc/jit/libgccjit.h
+++ b/gcc/jit/libgccjit.h
@@ -68,6 +68,7 @@ typedef struct gcc_jit_result gcc_jit_result;
 	     +- gcc_jit_lvalue
 		 +- gcc_jit_param
 	 +- gcc_jit_case
+	 +- gcc_jit_extended_asm
 */
 typedef struct gcc_jit_object gcc_jit_object;
 
@@ -138,6 +139,9 @@ typedef struct gcc_jit_param gcc_jit_param;
    destination block.  */
 typedef struct gcc_jit_case gcc_jit_case;
 
+/* FIXME.  */
+typedef struct gcc_jit_extended_asm gcc_jit_extended_asm;
+
 /* Acquire a JIT-compilation context.  */
 extern gcc_jit_context *
 gcc_jit_context_acquire (void);
@@ -1503,6 +1507,98 @@ gcc_jit_version_minor (void);
 extern int
 gcc_jit_version_patchlevel (void);
 
+/**********************************************************************
+ Asm support.
+ **********************************************************************/
+
+/* Functions for adding inline assembler code, analogous to GCC's
+   "extended asm" syntax.
+
+   See https://gcc.gnu.org/onlinedocs/gcc/Using-Assembly-Language-with-C.html
+
+   FIXME: note about API entrypoints and version.
+   FIXME.  */
+
+#define LIBGCCJIT_HAVE_gcc_jit_block_add_extended_asm
+
+/* Create a gcc_jit_extended_asm for an extended asm statement
+   with no control flow (i.e. without the goto qualifier).
+
+   The asm_template parameter  corresponds to the AssemblerTemplate
+   within C's extended asm syntax.  It must be non-NULL.  */
+
+extern gcc_jit_extended_asm *
+gcc_jit_block_add_extended_asm (gcc_jit_block *block,
+				gcc_jit_location *loc,
+				const char *asm_template);
+
+/* Create a gcc_jit_extended_asm for an extended asm statement
+   that may perform jumps, and use it to terminate the given block.
+   This is equivalent to the "goto" qualifier in C's extended asm
+   syntax.  */
+
+extern gcc_jit_extended_asm *
+gcc_jit_block_end_with_extended_asm_goto (gcc_jit_block *block,
+					  gcc_jit_location *loc,
+					  const char *asm_template,
+					  int num_goto_blocks,
+					  gcc_jit_block **goto_blocks,
+					  gcc_jit_block *fallthrough_block);
+
+/* Upcasting from extended asm to object.  */
+
+extern gcc_jit_object *
+gcc_jit_extended_asm_as_object (gcc_jit_extended_asm *ext_asm);
+
+/* Set whether the gcc_jit_extended_asm has side-effects, equivalent to
+   the "volatile" qualifier in C's extended asm syntax.  */
+
+extern void
+gcc_jit_extended_asm_set_volatile_flag (gcc_jit_extended_asm *ext_asm,
+					int flag);
+
+/* Set the equivalent of the "inline" qualifier in C's extended asm
+   syntax.  */
+
+extern void
+gcc_jit_extended_asm_set_inline_flag (gcc_jit_extended_asm *ext_asm,
+				      int flag);
+
+/* Add an output operand to the extended asm statement.
+   "asm_symbolic_name" can be NULL.
+   "constraint" and "dest" must be non-NULL.
+   This function can't be called on an "asm goto" as such instructions
+   can't have outputs  */
+
+extern void
+gcc_jit_extended_asm_add_output_operand (gcc_jit_extended_asm *ext_asm,
+					 const char *asm_symbolic_name,
+					 const char *constraint,
+					 gcc_jit_lvalue *dest);
+
+/* Add an input operand to the extended asm statement.
+   "asm_symbolic_name" can be NULL.
+   "constraint" and "src" must be non-NULL.  */
+
+extern void
+gcc_jit_extended_asm_add_input_operand (gcc_jit_extended_asm *ext_asm,
+					const char *asm_symbolic_name,
+					const char *constraint,
+					gcc_jit_rvalue *src);
+
+/* Add "victim" to the list of registers clobbered by the extended
+   asm statement.  It must be non-NULL.  */
+
+extern void
+gcc_jit_extended_asm_add_clobber (gcc_jit_extended_asm *ext_asm,
+				  const char *victim);
+
+/* FIXME.  */
+
+extern void
+gcc_jit_context_add_top_level_asm (gcc_jit_context *ctxt,
+				   const char *asm_stmts);
+
 #ifdef __cplusplus
 }
 #endif /* __cplusplus */
